/* 
 * CSE142, Spring 1999
 * Homework 4
 * Traffic animation

Craig T. Nishina

CSE142 section BB
 *
 *
 */


#include "gp142.h"
#include <stdio.h>
#include <math.h>

#include <time.h>

/* Logical constants */
#define TRUE    		1
#define FALSE   		0

#define FILL 0

/* Menu buttons: */

/* Top-left coordinates of button palette */
#define MENU_TOP		(GP142_YMAX - 5)
#define MENU_LEFT		(-GP142_XMAX + 5)

/* Height and width of buttons in pixels */
#define BUTTON_HEIGHT  	25
#define BUTTON_WIDTH 	95

/* Number of buttons */
#define NUM_BUTTONS 	7

/* Possible locations of mouse clicks: */

/*   Mouse click in some button */
#define BUTTON_CLICK 1

/*   Mouse click elsewhere */
#define OTHER_CLICK 0


/* Coordinates of objects in the drawing */

/* y-coordinate of the top of the ground in the landscape */
#define HORIZON (- 2 * (GP142_YMAX / 10))

/* Vertical center and width of highway */
#define HIGHWAY_CENTER ((-GP142_YMAX + HORIZON) / 3)
#define HIGHWAY_WIDTH  10


/* Maximum number of vehicles that can appear in the animation */
#define MAX_VEHICLES		5

/* Height and width of a single car */
#define CAR_HEIGHT 24
#define CAR_WIDTH  40

/* Kenny and Kyle */
#define KENNY_X		10
#define KENNY_Y		(HORIZON + 36)
#define KYLE_X		KENNY_X + 80
#define KYLE_Y		KENNY_Y
/*****************************************************************************

     FUNCTION PROTOTYPES

*****************************************************************************/


/* Draw the background, including the sun at coordinates sun_x and sun_y */
void draw_landscape(int sun_x, int sun_y);

/* Draw the buttons */
void draw_buttons();

/* Return kind of mouse click (in a button, etc.) */
int  classify_mouse_click(int mouse_x, int mouse_y);

/* Process button click at location x, y.  Update car speed,  */
/* direction, color, and whether traffic is moving as needed. */
void handle_button(int x, int y, int *traffic_moving, int *car_speed,
				   int *car_direction, int *car_color, int *kenny_count);

/* Update sun coordinates sun_x, sun_y for one tick */
void move_sun(int *sun_x, int *sun_y);

/* Update all vehicle x, y coordinates, given current x, y */
void kill_kenny(int *x);

/* location, direction (+1 or -1), and speed in pixels per tick. */
void move_traffic(int *x, int *y, int *direction, int speed);

/* Draw all vehicles given their current x, y coordinates and color */
void draw_traffic(int x, int y, int color);

/* Draw a single car of the given color with horizontal */
/* center x and bottom y*/
void draw_car(int x, int y, int color);
void draw_kenny(int x, int *kenny_count);
void draw_kyle(int x);
void draw_burnt_kenny (int x,int kenny_count, int color1, int color2);
/* Display error message if internal error is detected. */
void something_is_wrong (void);


/*****************************************************************************

     MAIN

*****************************************************************************/

/*
 * Main program contents:
 *   - Major program variables that persist throughout execution
 *   - Event loop that processes GP142 events until the user quits,
 *     and updates variables and redraws the window as needed.
 */
int main(void)
{
	/* Event handling and buttons: */
	int  quit;				/* = "user has selected quit"				*/
	int  event;				/* the most recent GP142 event				*/
	char key_pressed;		/* last keyboard character from key event	*/
	int  mouse_x, mouse_y;	/* x and y coordinates of latest mouse event*/
	int  click_kind;		/* kind of mouse click (button, etc.)		*/

	/* Information about the sun: */
	int sun_x, sun_y;			/* screen x and y coordinates */

	/* Information about vehicles in the animation:							*/
	/* [Only one car now - will need to be changed to add more]				*/
	int car_x [MAX_VEHICLES];
	int car1_y;		/* current position of the car					*/
	int car_direction [MAX_VEHICLES];		/* current direction: +1=right, -1=left			*/
	int car_color [MAX_VEHICLES];			/* color of the car								*/
	int car_speed;			/* speed in pixels per tick when traffic moving	*/	
	int traffic_moving;		/* = "traffic is currently moving"				*/
	
/*MAKE DA KINE*/
	int car2_y;

	int i;
	int x= 0;
	int kenny_count = 0;
	
	/* Initialize graphics package, clear the window,	*/
	/* turn logging off, and start animation.			*/
	GP142_open();
	GP142_logging(LOG_OFF);
	GP142_clear();
	GP142_animate(ANI_RUN);

	/* set initial location of the sun */
	sun_x = GP142_XMAX - 50;
	sun_y = GP142_YMAX - 35;

	/* set initial conditions for the car */
	car_color[0] = RED;
	for (i = 1; i < MAX_VEHICLES; i++)
	car_color [i] = car_color[i-1] + 1;
	
	car_x[0] = -GP142_XMAX;
	car_x[1] = 0;
	car_x[2] = GP142_XMAX;
	car_x[3] = 0;
	car_x[4] = GP142_XMAX;
	car1_y = HIGHWAY_CENTER;
	car2_y = HIGHWAY_CENTER-HIGHWAY_WIDTH;

	for (i = 0; i < (MAX_VEHICLES - 2); i++)
		car_direction [i] = + 1;
	
	for (i = 3; i < MAX_VEHICLES; i++)
		car_direction [i] = -1;
	car_speed = 5;
	traffic_moving = TRUE;

	


	
	/* Draw initial landscape, buttons, and traffic */
	draw_landscape(sun_x,sun_y);
	draw_buttons( );
	for (i= 0; i < (MAX_VEHICLES - 2); i++)
	draw_traffic(car_x[i], car1_y, car_color[i]);
	for (i= 3; i < MAX_VEHICLES; i++)
	draw_traffic(car_x[i], car2_y, car_color[i]);
	draw_kenny(x, &kenny_count);
	draw_kyle(x);
	/*
	 * Main event loop:
	 * ---- ----- -----
	 * Wait for the next user action, decode it, and call an
	 * appropriate function to handle it.  Repeat until the
	 * user selects quit.
	 */
	quit = FALSE;
	while (!quit) {
		
		/* get next event */
		event = GP142_await_event(&mouse_x, &mouse_y, &key_pressed);
		
		/* perform appropriate action depending on kind of event */
		switch (event) {
		case GP142_QUIT:
			/* Quit selected */
			quit = TRUE;
			break;
			
		case GP142_KBD:
			/* Key pressed.  Not used now.  If the program should		*/
			/* react to keyboard events, insert something appropriate	*/
			/* here.  Note that scanf CANNOT be used with GP142.		*/
			break;
			
		case GP142_MOUSE:
			/* Mouse click.  Determine if in a menu button	*/
			/* or elsewhere and process accordingly.		*/
			click_kind = classify_mouse_click(mouse_x, mouse_y);
			if (click_kind == BUTTON_CLICK) {
				for (i = 0; i < (MAX_VEHICLES - 2); i++)
				handle_button(mouse_x, mouse_y, &traffic_moving, &car_speed,
								&car_direction[i], &car_color[i], &kenny_count);
				for (i= 3; i < MAX_VEHICLES; i++)
				handle_button(mouse_x, mouse_y, &traffic_moving, &car_speed, 
								&car_direction[i], &car_color[i], &kenny_count);
			} else {
				/* insert code here (and additional else-if statements) */
				/* to react to mouse clicks elsewhere on the screen */
			}
			break;
			
		case GP142_PERIODIC:
			/* Timer interval event.  Update everything	*/
			/* that needs to change as time advances.	*/
			move_sun(&sun_x, &sun_y);
			kill_kenny(&x);
			if (traffic_moving)
			{

				for (i = 0; i< (MAX_VEHICLES - 2); i++)
				move_traffic(&car_x [i], &car1_y, &car_direction[i], car_speed);
				for (i= 3; i < MAX_VEHICLES; i++)
				move_traffic(&car_x [i], &car2_y, &car_direction[i], car_speed);
			}
			break;
			
		default:
			/* unknown event */
			break;
			
		}  /*end switch */
		
		/* Redraw everything */
		draw_landscape(sun_x, sun_y);
		draw_buttons();
		for (i= 0; i < (MAX_VEHICLES - 2); i++)
		draw_traffic(car_x[i], car1_y, car_color [i]);
		for (i= 3; i < MAX_VEHICLES; i++)
		draw_traffic(car_x[i], car2_y, car_color[i]);
		draw_kenny (x, &kenny_count);
		draw_kyle (x);
	
	}  /* end event loop */
	
	
	/* Termination: shut down graphics window and exit */
	GP142_close();
	return 0;
}  /*end main */


/*****************************************************************************

     BACKGROUND LANDSCAPE

*****************************************************************************/


/* Draw the background, including the sun at coordinates sun_x and sun_y */
void draw_landscape(int sun_x, int sun_y)
{
	int text_offset = -GP142_XMAX + 15;	/* horizontal offset of text */
	int text_size   = 12;				/* size of text font */

	/* Draw the sky */
	GP142_rectangleXY(ICE_BLUE, -GP142_XMAX, -GP142_YMAX,
		GP142_XMAX, GP142_YMAX, FILL);
	
	/* Draw the sun */
	GP142_circleXY(YELLOW, sun_x, sun_y , 20);
	
	/* Draw the ground, highway, and text legend */
	GP142_rectangleXY(BROWN, -GP142_XMAX, -GP142_YMAX,
		GP142_XMAX, HORIZON, FILL);

	GP142_rectangleXY(WHITE, 
					-GP142_XMAX, HIGHWAY_CENTER - HIGHWAY_WIDTH,
					 GP142_XMAX, HIGHWAY_CENTER + HIGHWAY_WIDTH,
					 FILL);

	GP142_rectangleXY(MED_GRAY,
					-GP142_XMAX, HIGHWAY_CENTER,
					GP142_XMAX, HIGHWAY_CENTER, FILL);

	GP142_printfXY (BLACK, text_offset, -GP142_YMAX+30, text_size,
		"Click a button to control the car.");
	
	
	/*Draw some mountains */
	GP142_triangleXY(MED_GRAY,
		-GP142_XMAX, HORIZON,
		GP142_XMAX, HORIZON,
		0, (4 * GP142_YMAX)/5 ,
		FILL);
	
	GP142_triangleXY(OLIVE,
		-( 5 * GP142_XMAX/4), HORIZON,
		(GP142_XMAX)/3  , HORIZON,
		-(3* GP142_XMAX)/4, (2 * GP142_YMAX)/3 ,
		FILL);
	
	GP142_triangleXY(FOREST_GREEN,
		-GP142_XMAX / 3 , HORIZON,
		GP142_XMAX, HORIZON,
		GP142_XMAX, (2 * GP142_YMAX)/3 ,
		FILL);


	
	
} /*end draw_landscape */



/*****************************************************************************/

/*DRAW SOUTH PARK*/

/*****************************************************************************/
void draw_kenny (int x, int *kenny_count)
{
	int color1;
	int color2;
	
	if (*kenny_count == 0)
	{
	
		GP142_circleXY(ORANGE,
			KENNY_X + x, KENNY_Y , 20);
		GP142_triangleXY(ORANGE,
			KENNY_X + x, KENNY_Y ,
			KENNY_X + x - 20, KENNY_Y - 35,
			KENNY_X + x + 20, KENNY_Y - 35,
			FILL);
		GP142_ovalXY(BROWN,
			KENNY_X + x - 2, KENNY_Y + 1,
			KENNY_X + x + 2, KENNY_Y - 11,
			18);
		GP142_ovalXY(CHALK, 
			KENNY_X + x, KENNY_Y, 
			KENNY_X + x, KENNY_Y - 10,
			15);
		GP142_circleXY(BLACK,
			KENNY_X + x + 5, KENNY_Y - 1, 7);
		GP142_circleXY(BLACK,
			KENNY_X + x - 5, KENNY_Y - 1, 7);
		GP142_circleXY(WHITE,
			KENNY_X + x + 5, KENNY_Y - 1, 6);
		GP142_circleXY(WHITE,
			KENNY_X + x - 5, KENNY_Y - 1, 6);
		GP142_circleXY(BLACK,
			 KENNY_X + x + 2, KENNY_Y, 1);
		GP142_circleXY(BLACK,
			KENNY_X + x - 2, KENNY_Y, 1);
		GP142_rectangleXY(BLACK,
			KENNY_X + x, KENNY_Y - 20,
			KENNY_X + x, KENNY_Y - 35,
			FILL);
	}
	else
		
	{
	/*explosion*/
		if ((*kenny_count%2) == 0)
		{
			color1=RED;
			color2=YELLOW;
			draw_burnt_kenny(x, *kenny_count, color1, color2);
			(*kenny_count)++;
		}
		else
		{
			color1=YELLOW;
			color2=RED;
			draw_burnt_kenny(x, *kenny_count, color1, color2);
			(*kenny_count)++;
		}
		if (*kenny_count == 10) *kenny_count = 0;
	}

}

void draw_burnt_kenny (int x, int kenny_count, int color1,
					   int color2)
{
	GP142_triangleXY(color1,
		KENNY_X + x, KENNY_Y + 60,
		KENNY_X + x - 50, KENNY_Y - 35,
		KENNY_X + x + 50, KENNY_Y - 35,
		FILL);
	GP142_triangleXY(color1,
		KENNY_X + x - 45, KENNY_Y + 30,
		KENNY_X + x - 60, KENNY_Y - 35,
		KENNY_X + x - 20, KENNY_Y - 35,
		FILL);
	GP142_triangleXY(color2,
		KENNY_X + x + 8, KENNY_Y + 40,
		KENNY_X + x - 9, KENNY_Y - 35,
		KENNY_X + x + 40, KENNY_Y - 35,
		FILL);
	GP142_triangleXY(color2,
		KENNY_X + x - 8, KENNY_Y + 40,
		KENNY_X + x + 9, KENNY_Y - 35,
		KENNY_X + x - 40, KENNY_Y - 35,
		FILL);
	GP142_triangleXY(color2,
		KENNY_X + x - 45, KENNY_Y + 15,
		KENNY_X + x - 52, KENNY_Y - 35,
		KENNY_X + x - 30, KENNY_Y - 35,
		FILL);
	GP142_triangleXY(color1,
		KENNY_X + x - 45, KENNY_Y - 10,
		KENNY_X + x - 48, KENNY_Y - 35,
		KENNY_X + x - 35, KENNY_Y - 35,
		FILL);
	GP142_triangleXY(color1,
		KENNY_X + x + 10, KENNY_Y + 10,
		KENNY_X + x - 10, KENNY_Y - 35,
		KENNY_X + x + 30, KENNY_Y - 35,
		FILL);
	GP142_triangleXY(color1,
		KENNY_X + x - 10, KENNY_Y + 10,
		KENNY_X + x + 10, KENNY_Y - 35,
		KENNY_X + x - 30, KENNY_Y - 35,
		FILL);
	
/*burnt kenny*/
	GP142_circleXY(BLACK,
		KENNY_X + x, KENNY_Y , 20);
	GP142_triangleXY(BLACK,
		KENNY_X + x, KENNY_Y ,
		KENNY_X + x - 20, KENNY_Y - 35,
		KENNY_X + x + 20, KENNY_Y - 35,
		FILL);
	GP142_circleXY(WHITE,
		KENNY_X + x + 5, KENNY_Y - 1, 6);
	GP142_circleXY(WHITE,
		KENNY_X + x - 5, KENNY_Y - 1, 6);
	GP142_circleXY(BLACK,
		 KENNY_X + x + 2, KENNY_Y, 1);
	GP142_circleXY(BLACK,
		KENNY_X + x - 2, KENNY_Y, 1);
	
		
}

/*DRAW KYLE*/
void draw_kyle (int x)
{
	GP142_triangleXY(ORANGE,
		KYLE_X + x , KYLE_Y ,
		KYLE_X + x - 18, KYLE_Y - 30,
		KYLE_X + x + 18, KYLE_Y - 30,
		FILL);
	GP142_rectangleXY(NAVY_BLUE,
		KYLE_X + x - 17, KYLE_Y - 35,
		KYLE_X + x + 17, KYLE_Y - 30,
		FILL);
	GP142_circleXY(CHALK, 
		KYLE_X + x, KYLE_Y , 15);
	GP142_circleXY(BLACK,
		KYLE_X + x + 5, KYLE_Y, 7);
	GP142_circleXY(BLACK,
		KYLE_X + x - 5, KYLE_Y, 7);
	GP142_circleXY(WHITE,
		KYLE_X + x + 5, KYLE_Y, 6);
	GP142_circleXY(WHITE,
		KYLE_X + x - 5, KYLE_Y, 6);
	GP142_circleXY(BLACK,
		 KYLE_X + x + 2, KYLE_Y, 1);
	GP142_circleXY(BLACK,
		KYLE_X + x - 2, KYLE_Y, 1);
	GP142_rectangleXY(BLACK,
		KYLE_X + x - 5, KYLE_Y - 11,
		KYLE_X + x + 5, KYLE_Y - 11,
		FILL);
	GP142_rectangleXY(SEA_GREEN,
		KYLE_X + x - 17, KYLE_Y + 8,
		KYLE_X + x + 17, KYLE_Y + 16, 
		FILL);
	GP142_rectangleXY(SEA_GREEN,
		KYLE_X + x + 17, KYLE_Y + 10,
		KYLE_X + x + 13, KYLE_Y,
		FILL);
	GP142_rectangleXY(SEA_GREEN,
		KYLE_X + x - 17, KYLE_Y + 10,
		KYLE_X + x - 13, KYLE_Y,
		FILL);
	GP142_rectangleXY(BLACK,
		KYLE_X + x, KYLE_Y - 16,
		KYLE_X + x, KYLE_Y - 35,
		FILL);

}


/*****************************************************************************

     BUTTONS AND MOUSE CLICKS

*****************************************************************************/


/* Draws the buttons */
void draw_buttons( )
{
	int i;
	int text_offset = MENU_LEFT+10;	/* offset of button text in button */
	int font_size = 12;				/* size of button text */
	
	/* draw rectangles for each button */
	for(i = 0; i < NUM_BUTTONS; i++) {
		GP142_rectangleXY(BLACK,
			MENU_LEFT,
			MENU_TOP - i * BUTTON_HEIGHT,
			MENU_LEFT + BUTTON_WIDTH,
			MENU_TOP - (i + 1)*BUTTON_HEIGHT, 1);
	}
	
	/* display button text */
	i = MENU_TOP - (BUTTON_HEIGHT/2) - (font_size/2);
	GP142_printfXY(FOREST_GREEN, text_offset, i, font_size, "Go");	
	
	i -= BUTTON_HEIGHT;
	GP142_printfXY(RED, text_offset, i, font_size, "Stop");
	
	i -= BUTTON_HEIGHT;
	GP142_printfXY(BLACK, text_offset, i, font_size, "Faster");
	
	i -= BUTTON_HEIGHT;
	GP142_printfXY(BLACK, text_offset, i, font_size, "Slower");
	
	i -= BUTTON_HEIGHT;
	GP142_printfXY(BLACK, text_offset, i, font_size, "Reverse");
	
	i -= BUTTON_HEIGHT;
	GP142_printfXY(BLACK, text_offset, i, font_size, "New Color");

	i -= BUTTON_HEIGHT;
	GP142_printfXY(BLACK, text_offset, i, font_size, "KILL KENNY!");
	
}

/* Classify mouse click at (mouse_x,mouse_y) and return kind */
int  classify_mouse_click(int mouse_x, int mouse_y)
{
	if ((mouse_x > MENU_LEFT) &&
		(mouse_x < MENU_LEFT + BUTTON_WIDTH) &&
		(mouse_y < MENU_TOP) &&
		(mouse_y > (MENU_TOP - NUM_BUTTONS*BUTTON_HEIGHT)))
		return BUTTON_CLICK;
	else
		return OTHER_CLICK;
}



/* Process button click at location x, y.  Update car speed,	*/
/* direction, color, and whether traffic is moving as needed.	*/
void handle_button(int x, int y, int *traffic_moving, int *car_speed,
				   int *car_direction, int *car_color, int *kenny_count)
{
	int buttonNum;		/* number of selected button */

	/* Complain if x coordinate couldn't be inside a button */
	if (x < MENU_LEFT || x > MENU_LEFT + BUTTON_WIDTH) {
		something_is_wrong();
		return;
	}
	
	/* Convert y coordinate to button number from top. */
	buttonNum = (MENU_TOP - y)/BUTTON_HEIGHT;	 
	
	switch(buttonNum) {
	case 0:
		/* go */
		*traffic_moving = TRUE;
		break;
	case 1:
		/* stop */
		*traffic_moving = FALSE;
		break;
		
	case 2:
		/* speed up */
		*car_speed = *car_speed + 1;
		break;
	case 3:
		/* slow down */
		*car_speed = *car_speed - 1;
		if (*car_speed < 0)
			*car_speed = 0;
		break;
		
	case 4:
		/* reverse */
		*car_direction = - *car_direction;
		break;

	case 5:
		/* change car color */
		*car_color = (*car_color+1) % MAX_COLORS;
		break;
	case 6:
		/* kill kenny */
		*kenny_count = 2;
		break;

	default:
		/*Bad news if this is ever reached! */
		something_is_wrong();
		break;
	}
}



/*****************************************************************************

     TRAFFIC AND OTHER ANIMATED OBJECTS

*****************************************************************************/
void kill_kenny(int *x){
if (*x < 2)
	(*x) ++;
else (*x)--;

}
/* Update sun coordinates sun_x, sun_y by one tick */
void move_sun(int *sun_x, int *sun_y) {
	/* Move the sun to the left.  If it reaches the edge, move it */
	/* to the other side and down a bit. */
	(*sun_x) --;
	if (*sun_x < -GP142_XMAX -30) {
		*sun_x = - *sun_x;
		(*sun_y) --;
	}
}


/* Update all vehicle x, y coordinates, given current x, y */
/* location, direction (+1 or -1), and speed in pixels per tick, */
void move_traffic(int *x, int *y, int *direction, int speed) {
	/* Note: If there is more than one vehicle, this should */
	/* be updated to adjust all vehicle coordinates */

	int trial_x;		/* new value for x coordinate */

	/* move vehicle.  If it moves off the edge, reverse direction */
	trial_x = *x + (*direction * speed);
	
	if (abs(trial_x) > GP142_XMAX + CAR_WIDTH/2)
	{
		*x = - (*x);
		(*x) --;
	}
	else
		*x = trial_x;

}


/* Draw all vehicles given their current x, y coordinates and color */
void draw_traffic(int x, int y, int color) {
	/* Note: needs to be changed if there is more than */
	/* one vehicle */

	draw_car(x,y,color);
}



/* Draw a single car of the given color with horizontal */
/* center x and bottom y*/
void draw_car(int x, int y, int color) {
	GP142_rectangleXY(color, x - CAR_WIDTH/2, y + CAR_HEIGHT/4,
						x + CAR_WIDTH/2, y + CAR_HEIGHT*3/4, FILL);
	GP142_rectangleXY(color, x - CAR_WIDTH/6, y + CAR_HEIGHT*3/4,
						x + CAR_WIDTH/6, y + CAR_HEIGHT, FILL);
	GP142_circleXY(BLACK, x - CAR_WIDTH/4, y + CAR_HEIGHT/4, CAR_HEIGHT/4);
	GP142_circleXY(BLACK, x + CAR_WIDTH/4, y + CAR_HEIGHT/4, CAR_HEIGHT/4);
}



/*****************************************************************************

     OTHER

*****************************************************************************/


/* Display error message if internal error is detected. */
void something_is_wrong (void) {
	GP142_printfXY (RED, 0, 0, 16, "BAAAADDD NEWS!");
}